------------------------------------------------------------------------------
-- Broker_ProfessionsMenu                                                   --
-- Author: Yargoro@Arathor-EU												--
-- Former Author: Sanori/Pathur                                             --
------------------------------------------------------------------------------
local _, ADDON = ...                                 --Includes all functions and variables
local MODNAME = "Broker_ProfessionsMenu"

--ADDON.MODNAME = MODNAME
ADDON.version = "Version: 7.0.3.3 (2016.Jul.29)"
ADDON.debug = false

--<< Include libs >>--
ADDON.dropdown = LibStub:GetLibrary('LibDewdrop-3.0')		--Dropdownmenu
ADDON.LDB = LibStub:GetLibrary("LibDataBroker-1.1")			--Data Broker
ADDON.TipHooker = LibStub:GetLibrary("LibTipHooker-1.1")	--Tooltip mod
ADDON.libst = LibStub:GetLibrary("ScrollingTable")			--include lib
ADDON.processable = LibStub:GetLibrary("LibProcessable");	--Processable
ADDON.QTip = LibStub:GetLibrary("LibQTip-1.0")

local core = LibStub("AceAddon-3.0"):NewAddon(MODNAME, "AceEvent-3.0","AceTimer-3.0", "AceBucket-3.0")--,"AceHook-3.0")

ADDON.L = LibStub("AceLocale-3.0"):GetLocale(MODNAME)

--<< Init variables and constants >>--
ADDON.quicklauncher = {}									--Quick Launcher
--ADDON.sharedcds = {}										--shared cds

ADDON.updaterframe = CreateFrame("Frame", nil, UIParent)
ADDON.updaterframe.allowScanning = false
ADDON.updaterframe:Hide()

ADDON.updaterframe:SetScript("OnUpdate", function(self, elapsed)
	if IsTradeSkillReady() then
		ADDON:Debug("updaterframe..ScanTradeSkillFrame")
		ADDON:ScanTradeSkillFrame()
		self:Hide()
	end
end)

ADDON.ignoredquickprofessions = {["Herbalism"] = "Herbalism",["Mining"] = "Mining",["Skinning"] = "Skinning",["Fishing"] = "Fishing"}

BPMAutoloot=nil												--Global Variable for Auto Loot Script
local my = UnitName("player")								--player name

local colorWhite =  "|cffffffff"
local colorBlack =  "|cff000000"
local colorGreen =  "|cff000000"
local colorYellow = "|cffffd100"

ADDON.dropdown.fontsizes = {"8","12","14","16","18"}

--<< Key short cuts >>--
ADDON.keys = {														--Keys
	{['Key']='left',       ['Button']=ADDON.L.leftclick},
	{['Key']='shiftleft',  ['Button']=ADDON.L.leftclick,  ['Mod']=ADDON.L.shift},
	{['Key']='altleft',    ['Button']=ADDON.L.leftclick,  ['Mod']=ADDON.L.alt},
	{['Key']='ctrlleft',   ['Button']=ADDON.L.leftclick,  ['Mod']=ADDON.L.ctrl},
	{['Key']='right',      ['Button']=ADDON.L.rightclick},
	{['Key']='shiftright', ['Button']=ADDON.L.rightclick, ['Mod']=ADDON.L.shift},
	{['Key']='altright',   ['Button']=ADDON.L.rightclick, ['Mod']=ADDON.L.alt},
	{['Key']='ctrlright',  ['Button']=ADDON.L.rightclick, ['Mod']=ADDON.L.ctrl},
}

function ADDON:KeyDownIndex(button)							--Index der gedrückten Tastenkombination
	local shift = IsShiftKeyDown();
	local ctrl  = IsControlKeyDown();
	local alt   = IsAltKeyDown();
	if (button=='LeftButton' and not shift and not ctrl and not alt) then return 1 end
	if (button=='LeftButton' and shift and not ctrl and not alt) then return 2 end
	if (button=='LeftButton' and not shift and not ctrl and alt) then return 3 end
	if (button=='LeftButton' and not shift and ctrl and not alt) then return 4 end
	if (button=='RightButton' and not shift and not ctrl and not alt) then return 5 end
	if (button=='RightButton' and shift and not ctrl and not alt) then return 6 end
	if (button=='RightButton' and not shift and not ctrl and alt) then return 7 end
	if (button=='RightButton' and not shift and ctrl and not alt) then return 8 end
end

function ADDON:Debug(msg)
	if self.debug and DEFAULT_CHAT_FRAME then
		DEFAULT_CHAT_FRAME:AddMessage(MODNAME .. " (dbg): " .. tostring(msg), 1.0, 0.37, 0.37)
	end
end 

--Table helper functions 

-- Print contents of `tbl`, with indentation. indent` sets the initial level of indentation.
function tprint(tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      ADDON:Debug(formatting)
      tprint(v, indent+1)
    elseif type(v) == 'boolean' then
      ADDON:Debug(formatting .. tostring(v))      
    else
      ADDON:Debug(formatting .. v)
    end
  end
end

function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

-- Remove key k (and its value) from table t. Return a new (modified) table.
function table.removeKey(t, k)
	local i = 0
	local keys, values = {},{}
	for k,v in pairs(t) do
		i = i + 1
		keys[i] = k
		values[i] = v
	end
 
	while i>0 do
		if keys[i] == k then
			table.remove(keys, i)
			table.remove(values, i)
			break
		end
		i = i - 1
	end
 
	local a = {}
	for i = 1,#keys do
		a[keys[i]] = values[i]
	end
 
	return a
end

--<< Table alphabetical sort function >>----------------------------------------
function pairsByKeys(t, f)
	local a = {}
	for n in pairs(t) do table.insert(a, n) end
		table.sort(a, f)
		local i = 0                                    --iterator variable
		local iter = function ()                       --iterator function
		i = i + 1
		if a[i] == nil then
			return nil
		else
			return a[i], t[a[i]]
		end
	end
	return iter
end

--<< Count of table elements >>-------------------------------------------------
function tcount(tab)
	local n = #tab
	if (n == 0) then
		for _ in pairs(tab) do
			n = n + 1
		end
	end
	return n
end


--------------------------------------------------------------------------------
-- Addon                                                                     --
--------------------------------------------------------------------------------

function core:OnInitialize()
--	self:RegisterEvent("PLAYER_REGEN_ENABLED","OnRegenEnable")
--	self:RegisterEvent("PLAYER_REGEN_DISABLED","OnRegenDisable")
	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("PLAYER_LOGOUT")
	self:RegisterEvent("PLAYER_REGEN_DISABLED")

	self:RegisterEvent("TRADE_SKILL_SHOW")
--	self:RegisterEvent("TRADE_SKILL_NAME_UPDATE")
--	self:RegisterEvent("TRADE_SKILL_UPDATE")
	self:RegisterBucketEvent("TRADE_SKILL_UPDATE",1)
	self:RegisterEvent("TRADE_SKILL_CLOSE")

--	self:RegisterEvent("TRAINER_SHOW")
--	self:RegisterEvent("TRAINER_UPDATE")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED","UNIT_SPELLCAST_FINISHED")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED","UNIT_SPELLCAST_FINISHED")
	self:RegisterEvent("LOOT_CLOSED")
	self:RegisterEvent("BAG_UPDATE")
end

-- function core:OnEnable()
-- 	self:RegisterBucketEvent("TRADE_SKILL_UPDATE", 1)
-- 	ADDON:Debug("OnEnable:")
-- end

function core:ADDON_LOADED()
	self:UnregisterEvent("ADDON_LOADED")
	ADDON:Debug("ADDON_LOADED:")
	if arg1 == ADDON.MODNAME then	
		--Default values
		if (Broker_ProfessionsMenu == nil) then Broker_ProfessionsMenu = {} end
		--Copy saves to internal var
		ADDON.save = Broker_ProfessionsMenu[GetRealmName()] or {}
		ADDON.TrainerDB = Broker_ProfessionsMenu["%TrainerDB%"] or {}
		local defaultsave = {						--default save values
			config = {
				bothfactions = false,
				menufontsize = "12",
				tooltip = {
					showcds = true,
					showskills = true,
					showbuttons = true,
					ShowAllTooltips = true,
					ShowIfYouCanCraftThisInItemTooltips = true,
				},
			},
			lastprofession = 0,
			cds = {},
			tradelinks = {},
			craftableitems = {},
			quicklauncher = {},
			quicklaunch = {
				left = 0,
				shiftleft = 0,
				altleft = 0,
				ctrlleft = 0,
				right = "menu",
				shiftright = "fav",
				altright = 0,
				ctrlright = 0,
			},
			favorites = {},
			faction = "",
			class = "",
		}
		--creates a new save tableb
		local function newsave(tbl, default)
			if (tbl==nil) then return default end		--if tbl is empty, then return default table/value
			if (next(default)==nil) then return tbl end	--if default is empty, then return tbl
			local result = {}
			for k,v in pairs(default) do
				if (tbl[k]==nil or type(v)=='table') then
					result[k] = newsave(tbl[k], v)	--recursive
				else
					result[k] = tbl[k]
				end
			end
			return result
		end
		ADDON.save[my] = newsave(ADDON.save[my], defaultsave)
	end
end
	
function core:PLAYER_LOGIN()
	ADDON:Debug("PLAYER_LOGIN")
	--Init LibDataBroker
	ADDON:InitLDB()
	
	ADDON.dropdown:SetFontSize(ADDON.save[my].config.menufontsize)

	--removed old invalidated launhers and Create enabled Launchers
	local remove = {} 
	for name,_ in pairsByKeys(ADDON:GetProfs(true,true,ADDON.ignoredquickprofessions)) do
		local id = ADDON:GetProfID(name)
		if (id) then
			remove[id] = id --table.insert(remove,id)
		end
	end

	local input = ADDON.save[my].quicklauncher
	for k,_ in pairs(input) do
		if not remove[k] then ADDON.save[my].quicklauncher = table.removeKey(ADDON.save[my].quicklauncher,k) end
	end

	for k,_ in pairs(ADDON.save[my].quicklauncher) do
		ADDON.quicklauncher[k]=ADDON:newlauncher(k)
	end

	--Modifying Atlasloot Recept Tooltips
	if AtlasLootTooltip then
		AtlasLootTooltip:HookScript("OnTooltipSetSpell", function(self, ...)
			ADDON:modifytooltip(self,select(3,self:GetSpell()))
		end)
	end
	--save players faction and class
	ADDON.save[my].faction = UnitFactionGroup("player")
	ADDON.save[my].class = select(2,UnitClass("player"))
end

function core:PLAYER_LOGOUT()
	ADDON:Debug("PLAYER_LOGOUT")
	Broker_ProfessionsMenu[GetRealmName()] = ADDON.save
	Broker_ProfessionsMenu["%TrainerDB%"] = ADDON.TrainerDB
end

function core:PLAYER_REGEN_DISABLED()
	ADDON:Debug("PLAYER_REGEN_DISABLED")
	
	for _,v in pairs(ADDON.quicklauncher) do
		v.secureframe:SetAttribute("type1", nil)
	end
end

function core:TRADE_SKILL_SHOW()
	ADDON:Debug("TRADE_SKILL_SHOW")
	ADDON.updaterframe.allowScanning = true
	ADDON.updaterframe:Show()
--	ADDON:ScanTradeSkillFrame()
end

-- function core:TRADE_SKILL_NAME_UPDATE()
-- 	ADDON:Debug("TRADE_SKILL_NAME_UPDATE")
-- 	ADDON:ScanTradeSkillFrame()
-- end

 function core:TRADE_SKILL_CLOSE()
 	ADDON:Debug("TRADE_SKILL_CLOSE")
	ADDON.updaterframe.allowScanning = false
	if not ADDON.updaterframe:IsVisible() then
		ADDON.updaterframe:Hide()
	end
 end

function core:TRADE_SKILL_UPDATE()
	ADDON:Debug("TRADE_SKILL_UPDATE")
	ADDON:ScanTradeSkillFrame()
end

function core:UNIT_SPELLCAST_SUCCEEDED(event,unitID,spell,rank,lineID,spellID)	--Autoloot and Dropdownmenu Refresh
	ADDON:Debug("UNIT_SPELLCAST_SUCCEEDED:"..unitID..","..spell)
--	ADDON:Debug("last profid:"..ADDON.save[my].lastprofession.." IsProfession:"..tostring(ADDON:IsProfession(spell)).." ProfID:"..ADDON:GetProfID(ADDON.save[my].lastprofession).."spellID:"..ADDON:TransProfID(ADDON:GetProfID(spell)))
	if unitID == "player" then
		if (ADDON.updaterframe.allowScanning == true and ADDON.save[my].lastprofession ~=nil and ADDON:IsProfession(spell) and ADDON:GetProfID(ADDON.save[my].lastprofession) ~= ADDON:TransProfID(ADDON:GetProfID(spell))) then
			ADDON:Debug("Profession trying to switch to:"..spell)
			ADDON:ScanTradeSkillFrame()
		elseif BPMAutoloot then
			SetCVar('AutoLootDefault', 1)
		end
	end
end

function core:UNIT_SPELLCAST_FINISHED(arg1)
	ADDON:Debug("UNIT_SPELLCAST_FINISHED")
	if arg1=="player" and BPMAutoloot then
		BPMAutoloot=nil
		SetCVar('AutoLootDefault', 0)
	end
end

function core:LOOT_CLOSED()
	ADDON:Debug("LOOT_CLOSED")
	if BPMAutoloot then
		BPMAutoloot=nil
		SetCVar('AutoLootDefault', 0)
	end
end

function core:BAG_UPDATE()
--	ADDON:Debug("BAG_UPDATE")
	if ADDON.dropdown:IsOpen(ADDON.dropdown.parent) then ADDON.dropdown:Refresh(2) end
end

function core:TRAINER_SHOW()
	ADDON:Debug("TRAINER_SHOW")
--Trainer Data Scan----------------------------------------------------------
	ADDON.TrainerServiceTypeFilter = {	--save setting
		available = GetTrainerServiceTypeFilter("available") and 1 or 0,
		unavailable= GetTrainerServiceTypeFilter("unavailable") and 1 or 0,
		used = GetTrainerServiceTypeFilter("used") and 1 or 0,
	}
	SetTrainerServiceTypeFilter("available",1)
	SetTrainerServiceTypeFilter("unavailable",1)
	ADDON.TrainerServiceTypeFilter.ready = true
	SetTrainerServiceTypeFilter("used",1)
end

function core:TRAINER_UPDATE()
	ADDON:Debug("TRAINER_UPDATE")
	if ADDON.TrainerServiceTypeFilter.ready then
		ADDON.TrainerServiceTypeFilter.ready = false
		if IsTradeskillTrainer() then
			local profid = ADDON:TransProfID(ADDON:GetSpellID(GetTrainerServiceSkillReq(1)))
			if profid then
				ADDON.TrainerDB[profid] = {}
				for i=1, GetNumTrainerServices() do
					ADDON.scantip:ClearLines();
					ADDON.scantip:SetTrainerService(i)
					local id = select(3,ADDON.scantip:GetSpell())
					if id then
						local skill,_ = select(2,GetTrainerServiceSkillReq(i))
						local cost,_ = GetTrainerServiceCost(i)
						ADDON.TrainerDB[profid][id]=strjoin(",",skill,cost)
					end
				end
			end
		end
		SetTrainerServiceTypeFilter("available",ADDON.TrainerServiceTypeFilter.available)	--restore settings
		SetTrainerServiceTypeFilter("unavailable",ADDON.TrainerServiceTypeFilter.unavailable)
		SetTrainerServiceTypeFilter("used",ADDON.TrainerServiceTypeFilter.used)
	end
	ClassTrainerFrame.scrollFrame.scrollBar:SetValue(0)
end


--------------------------------------------------------------------------------
-- Modifying Tooltips                                                         --
--------------------------------------------------------------------------------

function ADDON:modifytooltip(tooltip,id,isitem)
	if not id or not tooltip or not ADDON.save[my].config.tooltip.ShowIfYouCanCraftThisInItemTooltips then return end
	local chars,prof
	for k,v in pairs(ADDON.save) do
		if v.faction==UnitFactionGroup("player") or ADDON.save[my].config.bothfactions then
			if v.craftableitems then
				for kk,vv in pairs(v.craftableitems) do
					local found
					if isitem then --Get ID of Henchant
						found = strfind(vv,"|%d+,"..id.."|") -- |ECHANT,ITEM|
					else
						found = strfind(vv,"|"..id..",%d+|")
					end
					if found then
						prof,_=GetSpellInfo(kk)
						if ADDON.save[my].config.bothfactions and v.faction=="Horde" then
							if not chars then chars=k.." ("..FACTION_HORDE..")" else chars=chars..", "..k.." ("..FACTION_HORDE..")" end
						elseif ADDON.save[my].config.bothfactions and v.faction=="Alliance" then
							if not chars then chars=k.." ("..FACTION_ALLIANCE..")" else chars=chars..", "..k.." ("..FACTION_ALLIANCE..")" end
						else
							if not chars then chars=k else chars=chars..", "..k end
						end
					end
				end
			end
		end
	end
	if prof then
		tooltip:AddLine(' ')
		tooltip:AddLine(prof..": "..chars,1,0.60,0)
		tooltip:Show()
	end
end

--[[
--local profid, NoSpezi, _profid=ADDON:TransProfID(tonumber(strmatch(GetTradeSkillListLink(),"|Htrade:%x+:(%d+)")))
local profid, NoSpezi, _profid=ADDON:TransProfID(tonumber(strmatch(GetTradeSkillListLink(),"\124Htrade:[^:]+:(%d+)")))
]]
--Modifying Item Tooltips
ADDON.TipHooker:Hook(function(self,...)
	local itemid = strmatch(select(2,self:GetItem()),"|Hitem:(%d+):")
	ADDON:modifytooltip(self,itemid,true)
end, "item")
--Modifying Enchant Recept Tooltips
hooksecurefunc(ItemRefTooltip, "SetHyperlink", function(self, ...)
	local arg1,_ = ...
	if select(1,strfind(arg1,"enchant:")) then
		local id=strmatch(arg1,"enchant:(%d+)")
		ADDON:modifytooltip(self,id)
	end
end)



--------------------------------------------------------------------------------
-- Data broker                                                                --
--------------------------------------------------------------------------------

--<< Main data broker >>--------------------------------------------------------
function ADDON:InitLDB()

	--Create LDB
	ADDON.dataobj = ADDON.LDB:NewDataObject("Broker_ProfessionsMenu",
	{
		type = "data source",
		icon = "Interface\\Icons\\Trade_BlackSmithing",
		text = ADDON.L["professions"],
		label = ADDON.L["professions"],
		OnEnter = function(self)
			ADDON:Broker_OnEnter(self)
		end,
		OnLeave = function(self)
			ADDON:Broker_OnLeave(self)
		end,
		OnClick = function(frame,button)
			ADDON:Broker_OnClick(frame,button)
		end,
	})

end

-------------------------------------------------------------------------------
-- Broker Functions                                                        --
--------------------------------------------------------------------------------

function ADDON:Broker_OnEnter(brokerframe)
	if InCombatLockdown() then return end
	if (ADDON.dropdown:IsOpen(brokerframe)) then return end
	ADDON:Debug("Broker_OnEnter")
	ADDON:CreateTooltip()
	ADDON.tooltip:Clear()
	ADDON.tooltip:SmartAnchorTo(brokerframe)
	ADDON.tooltip:SetAutoHideDelay(0.1, brokerframe)
	ADDON:ShowTooltip()
end

function ADDON:Broker_OnLeave(brokerframe)
	ADDON:Debug("Broker_OnLeave")
end

function ADDON:Broker_OnClick(brokerframe,button)
	if InCombatLockdown() then return end
	ADDON:Debug("Broker_OnClick")

	local key = ADDON.keys[ADDON:KeyDownIndex(button)]
	if not key then return end
	local id = ADDON.save[my].quicklaunch[key.Key]
	if (id==-1 and ADDON.save[my].lastprofession > 0) then
		ADDON:ShowOrToggleTradeSkillFrame(ADDON.save[my].lastprofession)
	elseif (id=='menu') then
		ADDON.DestroyTooltip()
		ADDON.dropdown:Open(brokerframe,'children', function(level, value) ADDON.dropdown:ShowMenu(level, value, self) end)
		ADDON.dropdown:SmartAnchorTo(brokerframe)
--	elseif (id=='fav') then
--		ADDON.dropdown:Open(brokerframe, 'children', function() ADDON.dropdown:ShowFavorites(self) end)
	elseif (id>0 and ADDON.save[my].lastprofession ~= id) then
		ADDON:ShowTradeSkillFrame(id)
	end
end

--<< Launchers >>---------------------------------------------------------------
function ADDON:newlauncher(profID)
	ADDON:Debug("newlauncher" .. profID)
	local profname,_,icon = GetSpellInfo(profID)
	if (not profname or not ADDON:IsProfession(profname) or ADDON.ignoredquickprofessions[profname]) then return nil end

	local launcher = {}
	launcher.dataobj = ADDON.LDB:NewDataObject(profname, {
		type = "launcher",
		label = profname,
		icon = icon,
		OnClick = function(frame,button)
			ADDON:ShowOrToggleTradeSkillFrame(profID)
		end,
	})

	return launcher
end
--------------------------------------------------------------------------------
-- ToolTip Functions                                                                  --
--------------------------------------------------------------------------------

--(All credit for this func goes to Tekkub and his picoGuild!)
function ADDON:GetTipAnchor(frame)                   --although used with dropdownmenu
	local x, y = frame:GetCenter()
	if not x or not y then return 'TOPLEFT', 'BOTTOMLEFT' end
	local hhalf = (x > UIParent:GetWidth() * 2 / 3) and 'RIGHT' or (x < UIParent:GetWidth() / 3) and 'LEFT' or ''
	local vhalf = (y > UIParent:GetHeight() / 2) and 'TOP' or 'BOTTOM'
	return vhalf..hhalf, frame, (vhalf == 'TOP' and 'BOTTOM' or 'TOP')..hhalf
end

function ADDON:GetTipAnchor2(frame)
	local x, y = frame:GetCenter()
	local hhalf = (x > UIParent:GetWidth() / 2) and 'RIGHT' or (x < UIParent:GetWidth() / 2) and 'LEFT' or ''
	local vhalf = (y > UIParent:GetHeight() / 2) and 'TOP' or 'BOTTOM'
	return vhalf..hhalf, frame, (vhalf == 'TOP' and 'BOTTOM' or 'TOP')..(hhalf == 'RIGHT' and 'LEFT' or 'Right')
end

local function DecimalToHex(r,g,b)
    return string.format("|cff%02x%02x%02x", r*255, g*255, b*255)
end

function ADDON:CreateTooltip()
	ADDON:Debug("CreateTooltip")
	local tooltip = ADDON.QTip:Acquire(MODNAME.."Tooltip", 2, "LEFT", "RIGHT")
	ADDON.tooltip = tooltip
end

function ADDON:DestroyTooltip()
	ADDON:Debug("DestroyTooltip")
	if ADDON.tooltip then
		ADDON.QTip:Release(ADDON.tooltip)
		ADDON.tooltip = nil
	end
end

--Main Tooltip
function ADDON:ShowTooltip()
	ADDON:Debug("ShowTooltip")

	ADDON.tooltip:Clear()
	ADDON.tooltip:AddHeader(MODNAME)
	ADDON.tooltip:AddSeparator()
	ADDON.tooltip:AddLine(ADDON.L["professions"])

	if (tcount({GetProfessions()})>0 and ADDON.save[my].config.tooltip.showskills) then
		for _,index in pairs({GetProfessions()}) do
			if index then
				local name, texture, rank, maxRank, numSpells, spelloffset, skillLine = GetProfessionInfo(index)
				local rankcolor = tonumber(rank) == tonumber(maxRank) and DecimalToHex(0,1,0) or DecimalToHex(1,0,0)
				local clickable = not ADDON.ignoredquickprofessions[name] and true or false
				local line = ADDON.tooltip:AddLine("|T"..texture..":16:16:0:0|t "..name,rankcolor..rank..colorWhite.."/"..colorYellow..maxRank)
				if (clickable) then
					ADDON.tooltip:SetLineScript(line,"OnMouseUp",function(var) ADDON:ShowOrToggleTradeSkillFrame(ADDON:GetProfID(name)) end)
				end
			end
		end
		--Pick Look
		local name,_,icon,_ = GetSpellInfo(1804)
		if GetSpellBookItemInfo(name) then
			ADDON.tooltip:AddSeparator()
			ADDON.tooltip:AddLine("|T"..icon..":16:16:0:0|t "..name,UnitLevel("player")*5)
		end
	end

	--Cooldowns
	if (ADDON.save[my].config.tooltip.showcds == true) then
		ADDON.tooltip:AddSeparator()

		local jj = nil
		local duration = 0

		ADDON.tooltip:AddLine(" ")
		ADDON.tooltip:AddLine(ADDON.L["cds"])
		for k,v in pairsByKeys(ADDON.save[my].cds) do
			duration = difftime(v,time())
			if duration>0 then
				jj=true
				ADDON.tooltip:AddLine("|cff00ff00"..k.."|r",SecondsToTime(duration))
			end
		end

		for k,v in pairsByKeys(ADDON.save) do
			if k~=my and v.cds~=nil and (ADDON.save[my].config.bothfactions or v.faction==UnitFactionGroup("player")) then
				local classcolor = RAID_CLASS_COLORS[v.class]
				for kk,vv in pairsByKeys(v.cds) do
					duration = difftime(vv,time())
					if duration>0 then
						jj=true
						ADDON.tooltip:AddLine(DecimalToHex(classcolor.r,classcolor.g,classcolor.b).."["..k.."] |cff00ff00"..kk,SecondsToTime(duration))
					end
				end
			end
		end
		if not jj then ADDON.tooltip:AddLine(ADDON.L["nocds"]) end
	end

	--Infos
	if (ADDON.save[my].config.tooltip.showbuttons == true) then
		ADDON.tooltip:AddSeparator()
		local line
		for _,key in pairs(ADDON.keys) do
			local text
			local script = nil
			local func = nil
			local id = ADDON.save[my].quicklaunch[key.Key]
			if (id==-1 and ADDON.save[my].lastprofession>0) then
				text = "*"..GetSpellInfo(ADDON.save[my].lastprofession).."*"
--				script = "OnEnter"
--				func = function(frame,...) frame:SetAttribute("type", "spell") frame:SetAttribute("spell", GetSpellInfo(ADDON.save[my].lastprofession)) end
			elseif (id=='menu') then
				text = ADDON.L["openmenu"]
			elseif (id=='fav') then
				text = ADDON.L["favorites"]
			elseif (id>0) then
				text = GetSpellInfo(id)
			end
			if (text and key.Mod) then
				line = ADDON.tooltip:AddLine(key.Mod..' + '..key.Button, "|cffffffff"..text.."|r")
			elseif (text) then
				line = ADDON.tooltip:AddLine(key.Button, "|cffffffff"..text.."|r")
			end
			-- if (script ~= nil and func ~= nil) then
			-- 	ADDON.tooltip:SetLineScript(line,script,func)
			-- 	script = nil
			-- 	func = nil
			-- end
		end
	end
	ADDON.tooltip:Show()
end


--------------------------------------------------------------------------------
-- Functions                                                                  --
--------------------------------------------------------------------------------

--<< Filter tradewindows and tradeskills >>-------------------------------------
function ADDON:GetProfs(sorted,nosubprofessions,ignoreproflist)
	if not nosubprofessions then nosubprofessions = false end
	local result={}
	--Ignorelist
	local ignore = {}
	local ignoreproflist = ignoreproflist and ignoreproflist or {}

--	tprint(ignoreproflist)

	--Additional
	local additional={--UnitClass("player") create atomaically the correct title
		[53428]=UnitClass("player"),	--Rune Forging
		[1804]=UnitClass("player"),		--Pick Look
	}

	--Professions
	for _,index in pairs({GetProfessions()}) do
		if index then
			local name, texture, rank, maxRank, numSpells, spelloffset, skillLine = GetProfessionInfo(index)
			if not ignoreproflist[name] then
				for i=1, numSpells do
					if (not ignore[name] and not IsPassiveSpell(spelloffset+i, BOOKTYPE_PROFESSION)) then
						local subname,_ = GetSpellBookItemName(spelloffset+i, BOOKTYPE_PROFESSION)
						if not ignore[subname] then
							if sorted then
								if not result[name] then result[name]={} end
								if not nosubprofessions then
									result[name][subname] = GetSpellBookItemTexture(spelloffset+i, BOOKTYPE_PROFESSION)
								else
									result[name] = GetSpellBookItemTexture(spelloffset+i, BOOKTYPE_PROFESSION)
								end
							else
								result[subname] = GetSpellBookItemTexture(spelloffset+i, BOOKTYPE_PROFESSION)
							end
						end
					end
				end
			end
		end
	end
	--Additional
	for id,title in pairs(additional) do
		local name,_,icon,_ = GetSpellInfo(id)
		if not ignoreproflist[name] then
			if GetSpellBookItemInfo(name) then
				if sorted then
					if not result[title] then result[title]={} end
					result[title][name] = icon
				else
					result[name] = icon
				end
			end
		end
	end
--	ADDON:Debug("result:")tprint(result)
	return result
end


--<< GetSpellId >>--------------------------------------------------------------
function ADDON:GetSpellID(spell)
	if not spell then return end
	local link,_ = GetSpellLink(spell)
	if not link then return end
--	return tonumber(strmatch(link,"|Hspell:(%d+)|h"))
--	return tonumber(link:match("spell:%d+"))
	return tonumber(link:match("|Hspell:(%d+)|h"));	
end

function ADDON:GetProfSkillID(spell)
	if not spell then return end
	local _,itemLink = GetSpellLink(spell)
	if not itemLink then return end
--	local itemLink = "|cffffd000|Htrade:Player-970-002E45A2:158758:197|h[Tailoring]" 
	local skillID = split(itemLink:match("|Htrade:(.-)|"),":")[3]
	--ADDON:Debug("spell:"..spell.."skillID:"..skillID)
	return skillID
end

function ADDON:GetProfID(prof)
	if not prof then return end
	local name, rank, icon, castingTime, minRange, maxRange, spellID = GetSpellInfo(prof)
	return spellID
end

function ADDON:IsProfession(spellID)
	for _,index in pairs({GetProfessions()}) do
		if index then
			local name = GetProfessionInfo(index)
			--ADDON:Debug("pf:"..name..":"..spellID)
			if (name == spellID) then return true end
		end
	end
	return false
end

--<< TradeSkillFrame: Scan for cooldowns end recepts >>-------------------------
function ADDON:ScanTradeSkillFrame()
--	due to blizzard bug or implementation TradeSkills infos not get under TRADE_SKILL_SHOW-event only later got valid information  
-- i create a dummy frame and wait for ready
	-- if not IsTradeSkillReady() then
	-- 	ADDON:Debug("Start updater")
	-- 	self.updaterframe:Show()
	-- 	return
	-- end

	if not IsTradeSkillLinked() and not IsTradeSkillGuild() and GetTradeSkillListLink() then
		--local profid, NoSpezi, _profid=ADDON:TransProfID(tonumber(strmatch(GetTradeSkillListLink(),"|Htrade:%x+:(%d+)")))
		local profid, NoSpezi, _profid=ADDON:TransProfID(tonumber(strmatch(GetTradeSkillListLink(),"\124Htrade:[^:]+:(%d+)")))
		
--		local tradeSkillID, skillLineName = C_TradeSkillUI.GetTradeSkillLineForRecipe(GetFirstTradeSkill())
--		ADDON:Debug("ScanTradeSkillFrame tradeSkillID:"..tradeSkillID)
--		strmatch(C_TradeSkillUI.GetTradeSkillListLink(),"\124Htrade:[^:]+:(%d+)")

		ADDON.save[my].lastprofession = profid;

		ADDON:Debug("ScanTradeSkillFrame-profid:"..profid.." NoSpezi:"..NoSpezi.." _profid:".._profid.." tradeSkillID:"..ADDON:GetProfSkillID(ADDON.save[my].lastprofession))

		--Remove deleted Profession
		local craftableitems = ADDON.save[my].craftableitems
		local tradelinks = ADDON.save[my].tradelinks
		ADDON.save[my].craftableitems = {}
		ADDON.save[my].tradelinks = {}
		for k,v in pairs(ADDON:GetProfs()) do
			--ADDON:Debug(k..v)
			local _NoSpezi, _k
			k, _NoSpezi, _k = ADDON:TransProfID(ADDON:GetSpellID(k))
			if craftableitems[k]~=nil then
				ADDON.save[my].craftableitems[k] = craftableitems[k]
			end
			if _NoSpezi and tradelinks[k]~=nil then
				ADDON.save[my].tradelinks[k] = tradelinks[k]
			elseif not _NoSpezi and tradelinks[_k]~=nil then
				ADDON.save[my].tradelinks[_k] = tradelinks[_k]
			end
		end

		ADDON.save[my].craftableitems[profid] = ""
		
		ADDON:Debug("ScanTradeSkillFrame --Scan recipes:"..tostring(GetNumTradeSkills()));

		local recipeIDs = C_TradeSkillUI.GetFilteredRecipeIDs();
    	for i, recipeID in ipairs(recipeIDs) do
			ADDON:ScanRecipe(recipeID)
		end
	end
end

function ADDON:ScanRecipe(id)
	local name,skilltype = GetTradeSkillInfo(id)
	if ( skillType ~= "header" and skillType ~= "subheader" ) then
--	if (skilltype~="header") then
		--ADDON:Debug("Scan recipe:"..name);
		local enchant=GetTradeSkillRecipeLink(id)
		local item=GetTradeSkillItemLink(id)
		local cd=GetTradeSkillCooldown(id)
		if cd then
			ADDON.save[my].cds[name] = time()+floor(cd+0.5)
			ADDON:Debug("ScanTradeSkillFrame --Scan Cd:"..ADDON.save[my].cds[name])
		elseif (ADDON.save[my].cds[name]) then
			ADDON.save[my].cds[name] = nil	--display toast window
		end
		if type(enchant)=="string" then
			enchant = strmatch(enchant,"|Henchant:(%d+)")
			if type(item)=="string" then
				item=strmatch(item,"|Hitem:(%d+):")
				if not item then item="0" end
			else
				item="0"
			end
--			ADDON:Debug("enchant:"..enchant.."item:"..item);
			local profid = ADDON.save[my].lastprofession
			if (enchant) then ADDON.save[my].craftableitems[profid] = ADDON.save[my].craftableitems[profid].."|"..enchant..","..item.."|" end
		end
	end
end
--<< Translate profession id to the id of rank one (for save purpos) >>---------
ADDON.profidtable={	--format {id of rank 1,id2,id3,id4,...,other ids[elixir master, etc.]}   ->   return "id of rank 1", "max skill"
	{2259,3101,3464,11611,28596,51304,80731,105206,156606,		28677,28675,28672},   -- Alchemy
	{2018,3100,3538,9785,29844,51300,76666,110396,158737},                            -- Blacksmithing
	{7411,7412,7413,13920,28029,51313,74258,110400,158716,		13262},               -- Enchanting
	{4036,4037,4038,12656,30350,51306,82774,110403,158739,		49383,20219,20222},   -- Engineering
	{2366,2368,3570,11993,28695,50300,74519,110413,158745,		2383},                -- Herbalism
	{45357,45358,45359,45360,45361,45363,86008,110417,158748,	51005},               -- Inscription
	{25229,25230,28894,28895,28897,51311,73318,110420,158750,	31252},               -- Jewelcrafting
	{2108,3104,3811,10662,32549,51302,81199,110423,158752},                           -- Leatherworking
	{2575,2576,3564,10248,29354,50310,74517,102161,158754,		2656,2580},           -- Mining
	{8613,8617,8618,10768,32678,50305,74522,102216,158756},                           -- Skinning
	{3908,3909,3910,12180,26790,51309,75156,110426,158758,		59390},               -- Tailoring
	{78670,88961,89718,89719,89720,89721,89722,110393,158762,	80451},               -- Archaeology
	{2550,3102,3413,18260,33359,51296,88053,104381,158765,		818},                 -- Cooking
	{3273,3274,7924,10846,27028,45542,74559,110406,158741},                           -- First Aid
	--{7620,7731,7732,18248,33095,51294,88868,110410,131474,131476,131490,158743},    -- Fishing
}
ADDON.profranks={75,150,225,300,375,450,525,600,700,800}

function ADDON:TransProfID(profid)
	if not profid then return end
	for _,v in pairs(ADDON.profidtable) do
		for kk,vv in pairs(v) do
			if (vv==profid) then
				local maxrank
				if kk<=table.getn(ADDON.profranks) then maxrank=ADDON.profranks[kk] end	--Bei WoD gibt es 9 Ränke
				return v[1], maxrank, profid
			end
		end
	end
	return profid, nil, profid
end

--<< Quicktradeskill scan function >>-------------------------------------------
-- List of all aviable quick trade skills and their localized name (for scanning of the tooltip)
local skills = {
	[GetSpellInfo(13262)] = ITEM_DISENCHANT_ANY_SKILL,
	[GetSpellInfo(51005)] = ITEM_MILLABLE,
	[GetSpellInfo(31252)] = ITEM_PROSPECTABLE,
}
-- Scanfuntion
function ADDON:scanBagForQuickTradeSkillItems(skillname, onlyAviableCheck)
	if (not (skillname and skills[skillname])) then return false end
	if (onlyAviableCheck) then return true end
	local result={}
	for i=0, NUM_BAG_SLOTS do
		for j=1, GetContainerNumSlots(i) do
			if GetContainerItemID(i,j) then
				local texture, itemCount, _, quality, _ = GetContainerItemInfo(i, j)
				--ADDON:Debug("texture"..texture)
				local itemid = GetContainerItemID(i,j);
				local itemName,_,_,_,itemMinLevel,itemType,itemSubType = GetItemInfo(itemid)
				-- Check
				local add = false 
				if (skills[skillname]==ITEM_MILLABLE and ADDON.processable:IsMillable(itemid) and itemCount>=5) then
					add = true;
				elseif (skills[skillname]==ITEM_PROSPECTABLE and ADDON.processable:IsProspectable(itemid) and itemCount>=5) then
					add = true;
				elseif (skills[skillname]==ITEM_DISENCHANT_ANY_SKILL and ADDON.processable:IsDisenchantable(itemid)) then
					add = true;
				--[[elseif (skills[skillname] == ITEM_DISENCHANT_ANY_SKILL) then --Disenchant
					if ((itemType==ENCHSLOT_WEAPON or itemType==ARMOR) and quality>1 and quality<5) then add = true end
				else -- Scan Tooltip
					ADDON.scantip:SetBagItem(i,j)
					for i=1, ADDON.scantip:NumLines() do
						if (_G["BPM_ScanTipTextLeft"..i] and _G["BPM_ScanTipTextLeft"..i]:GetText()==skills[skillname] and itemCount>=5) then
							add = true
							break
						end
					end]]
				end
				-- Create Entry
				if (add) then
					if (itemCount>1) then itemCount = " ("..itemCount..")" else itemCount="" end
					result[quality.."-"..itemName.."-"..i.."-"..j] = {
						name="|c"..select(4,GetItemQualityColor(quality))..itemName..itemCount.."|r",
						icon=tostring(texture),--Legion not real number menu only allowed string
						action={
							["type1"]="macro",
							["macrotext"]="/script if(GetCVar('AutoLootDefault')=='0') then BPMAutoloot=true end\n/cast "..skillname.."\n/use "..i.." "..j
						},
						tooltip=function()
							self = GameTooltip:GetOwner()
							GameTooltip:SetOwner(self, "ANCHOR_NONE")
							GameTooltip:ClearAllPoints()
							GameTooltip:SetPoint(ADDON:GetTipAnchor2(self))
							GameTooltip:SetBagItem(i,j)
							GameTooltip:AddLine(" ")
							GameTooltip:AddLine(ADDON.L["leftclick"]..": "..skillname..ADDON.L["autoloot"],0,1,0)
						end,
					}
				end
			end
		end
	end
	return result
end



-- View professions of other chars
function ADDON:OpenAltProfFrame(name, profid)
	if not ADDON.AltProfFrame then -- Call only once
		ADDON.AltProfFrame = {}
		ADDON.AltProfFrame.frame = CreateFrame("FRAME")
		ADDON.AltProfFrame.frame:SetFrameStrata("MEDIUM")
		ADDON.AltProfFrame.frame:SetWidth(300)
		ADDON.AltProfFrame.frame:SetHeight(306)
		ADDON.AltProfFrame.frame:SetBackdrop({
			bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
			tile = true, tileSize = 16, edgeSize = 16, 
			insets = { left = 4, right = 4, top = 4, bottom = 4 }
		})
		ADDON.AltProfFrame.frame:SetBackdropColor(0,0,0,1)
		ADDON.AltProfFrame.frame:SetPoint("TOPLEFT",15,-130)
		ADDON.AltProfFrame.frame:EnableMouse(true)
		
		ADDON.AltProfFrame.frame:SetScript("OnMouseDown", function(self, button)
			if button=="LeftButton" then
				self:StartMoving()
			end
		end)
		ADDON.AltProfFrame.frame:SetScript("OnMouseUp", function(self, button)
			if button=="LeftButton" then
				self:StopMovingOrSizing()
				self:SetUserPlaced(false)
			end
		end)
		ADDON.AltProfFrame.frame:SetMovable(true)
		
		-- Close Button
		ADDON.AltProfFrame.button = CreateFrame("Button",nil,ADDON.AltProfFrame.frame,"UIPanelCloseButton")
		--ADDON.AltProfFrame.button:SetFrameStrata(ADDON.AltProfFrame.frame:GetFrameStrata())
		ADDON.AltProfFrame.button:SetPoint("TOPRIGHT", ADDON.AltProfFrame.frame, "TOPRIGHT")
		
		-- Font Strin
		ADDON.AltProfFrame.title = ADDON.AltProfFrame.frame:CreateFontString(nil, "ARTWORK")
		ADDON.AltProfFrame.title:SetFontObject(GameFontNormal)
		ADDON.AltProfFrame.title:SetPoint("TOPLEFT", ADDON.AltProfFrame.frame, "TOPLEFT", 8, -7)
		
		ADDON.AltProfFrame.prof = ADDON.AltProfFrame.frame:CreateFontString(nil, "ARTWORK")
		ADDON.AltProfFrame.prof:SetFontObject(GameFontNormal)
		ADDON.AltProfFrame.prof:SetPoint("TOPLEFT", ADDON.AltProfFrame.title, "BOTTOMLEFT", -3, -3)
		
		-- Search bar
		ADDON.AltProfFrame.search = CreateFrame("EditBox",nil,ADDON.AltProfFrame.frame,"InputBoxTemplate")
		ADDON.AltProfFrame.search:SetPoint("TOPLEFT",ADDON.AltProfFrame.prof,"BOTTOMLEFT",5,-3)
		ADDON.AltProfFrame.search:SetWidth(285)
		ADDON.AltProfFrame.search:SetHeight(20)
		ADDON.AltProfFrame.search:SetFontObject("ChatFontSmall")
		ADDON.AltProfFrame.search:SetAutoFocus(false)
		ADDON.AltProfFrame.search:SetScript("OnTextChanged", function(self)
			local text = self:GetText()
			if text==nil or text=="" then
				ADDON.AltProfFrame.ScrollFrame:SetFilter(function(self, row) return true end)
			else
				ADDON.AltProfFrame.ScrollFrame:SetFilter(function(self, row)
					if strfind(strlower(row.cols[2].value), strlower(text)) then
						return true
					end
					return false
				end)
			end
		end)
		ADDON.AltProfFrame.search:SetScript("OnEnterPressed", EditBox_ClearFocus)
		ADDON.AltProfFrame.search:SetScript("OnEscapePressed", EditBox_ClearFocus)
		ADDON.AltProfFrame.search:SetScript("OnEditFocusLost", EditBox_ClearHighlight)
		ADDON.AltProfFrame.search:SetScript("OnEditFocusGained", EditBox_HighlightText)
		--ADDON.AltProfFrame.search:SetTextInsets(16, 0, 0, 0);
		
		ADDON.AltProfFrame.ScrollFrame = ADDON.libst:CreateST({
			{
				["width"] = 20,			--icon
				["align"] = "center",
			},
			{
				["width"]=241,				--name
				["align"]="left",
				["sort"] = "desc",
			},
		},13,18,{["r"] = 0,["g"] = 0.2,["b"] = 1.0,["a"] = 0.3},ADDON.AltProfFrame.frame)
		ADDON.AltProfFrame.ScrollFrame.frame:Hide()
		ADDON.AltProfFrame.ScrollFrame.frame:SetPoint("TOPLEFT",ADDON.AltProfFrame.search,"BOTTOMLEFT",-7,-3)		
		
		ADDON.AltProfFrame.ScrollFrame:RegisterEvents({
			["OnShow"] = function(rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, ...)
				if (not row) then
					cellFrame:Hide()	--hide title line
				end
			end,
			["OnEnter"] = function(rowFrame, cellFrame, data, cols, row, realrow, column, scrollingTable, ...)
				if not data or not row or not data[realrow] or not data[realrow]["cols"][2]["id"] then return end
				GameTooltip:SetOwner(ADDON.AltProfFrame.frame, "ANCHOR_NONE")
				GameTooltip:ClearAllPoints()
				GameTooltip:SetPoint("TOPLEFT",ADDON.AltProfFrame.frame,"BOTTOMLEFT",42,0)
				GameTooltip:SetSpellByID(data[realrow]["cols"][2]["id"])
				--GameTooltip:AddLine(" ")
				--GameTooltip:AddLine("Click: Link in chat")
				GameTooltip:Show()
			end,
			["OnLeave"] = function()
				GameTooltip:Hide()
			end,
			["OnClick"] = function(rowFrame, cellFrame, data, cols, row, realrow, column, table, button, ...)
				if not data or not row or not data[realrow] or not data[realrow]["cols"][2]["id"] then return true end
				local link = GetSpellLink(data[realrow]["cols"][2]["id"])
				if (not ChatEdit_InsertLink(link) ) then
					ChatFrame1EditBox:Show()
					ChatEdit_InsertLink(link)
				end
				return true
			end,
		})
	end
	ADDON.AltProfFrame.ScrollFrame.frame:Show()
	
	local prof, _, proficon = GetSpellInfo(profid)
	if prof then
		--if (ADDON.save[name].class) then
		--	local coords = CLASS_ICON_TCOORDS[ADDON.save[name].class]
		--	ADDON.AltProfFrame.title:SetText("|TInterface\\Glues\\CharacterCreate\\UI-CharacterCreate-Classes:0:0:0:0:100:100:"..coords[1]..":"..coords[2]..":"..coords[3]..":"..coords[4].."|t"..name)
		--else
		ADDON.AltProfFrame.title:SetText(name)
		--end
		ADDON.AltProfFrame.prof:SetText("|T"..proficon..":0:0:0:0|t|cffffffff"..prof.."|r")
		local table = {}
		
		for _, item in pairs({strsplit("|", ADDON.save[name].craftableitems[profid])}) do
			if item~="" then
				local recipeid, itemid = strsplit(",", item)
				local name, _, icon = GetSpellInfo(recipeid)
				if name and name~="" then
					if icon and icon~="" then
						icon = "|T"..icon..":16:16:0:0|t"
					else
						icon = ""
					end
					tinsert(table,{
						["cols"] = {
							{
								["value"] = icon,
							},
							{
								["value"] = name,
								["id"] = recipeid,
								["color"] = {r=1.0,g=0.81,b=0},
							},
						},
					})
				end
			end
		end
		ADDON.AltProfFrame.ScrollFrame:SetData(table)
		
		ADDON.AltProfFrame.frame:Show()
	end
end

-- Blizzard Trade Skill fixes (legion changes) Thx icyblade
function GetAuctionItemClasses()
    --[[
    return {
        [1]  = AUCTION_CATEGORY_WEAPONS, -- 第一个必须是武器
        [2]  = AUCTION_CATEGORY_ARMOR, -- 第二个必须是护甲
        [3]  = AUCTION_CATEGORY_CONTAINER,
        [4]  = AUCTION_CATEGORY_CONSUMABLES,
        [5]  = AUCTION_CATEGORY_GLYPHS,
        [6]  = AUCTION_CATEGORY_TRADE_GOODS,
        [7]  = AUCTION_CATEGORY_RECIPES,
        [8]  = AUCTION_CATEGORY_GEMS,
        [9]  = AUCTION_CATEGORY_MISCELLANEOUS,
        [10] = AUCTION_CATEGORY_QUEST_ITEMS,
        [11] = AUCTION_CATEGORY_BATTLE_PETS,
        [12] = AUCTION_CATEGORY_ITEM_ENHANCEMENT,
    }]]
    return AUCTION_CATEGORY_WEAPONS,AUCTION_CATEGORY_ARMOR,AUCTION_CATEGORY_CONTAINER,AUCTION_CATEGORY_CONSUMABLES,AUCTION_CATEGORY_GLYPHS,AUCTION_CATEGORY_TRADE_GOODS,AUCTION_CATEGORY_RECIPES,AUCTION_CATEGORY_GEMS,AUCTION_CATEGORY_MISCELLANEOUS,AUCTION_CATEGORY_QUEST_ITEMS,AUCTION_CATEGORY_BATTLE_PETS,AUCTION_CATEGORY_ITEM_ENHANCEMENT
end

function GetAuctionInvTypes(classIndex, subClassIndex)
    if classIndex == 2 and subClassIndex == 1 then
        return 'INVTYPE_HEAD', true, 'INVTYPE_NECK', true, 'INVTYPE_SHOULDER', false, 'INVTYPE_BODY', true, 'INVTYPE_CHEST', false, 'INVTYPE_WAIST', false, 'INVTYPE_LEGS', false, 'INVTYPE_FEET', false, 'INVTYPE_WRIST', false, 'INVTYPE_HAND', false, 'INVTYPE_FINGER', true, 'INVTYPE_TRINKET', true, 'INVTYPE_CLOAK', true, 'INVTYPE_HOLDABLE', true
    else
        print('Not implemented yet')
    end
end

function GetTradeSkillLine()
    -- local tradeskillName, currentLevel, maxLevel = GetTradeSkillLine();
    local id, tradeskillName, currentLevel, maxLevel = C_TradeSkillUI.GetTradeSkillLine()
    if tradeskillName ~= nil then
        return tradeskillName, currentLevel, maxLevel
    else
        return 'UNKNOWN', 0, 0
    end
end

function IsNPCCrafting()
    return C_TradeSkillUI.IsNPCCrafting()
end

function GetNumTradeSkills()
    return #C_TradeSkillUI.GetFilteredRecipeIDs()
end

function IsTradeSkillReady()
	return C_TradeSkillUI.IsTradeSkillReady()
end

function IsTradeSkillLinked()
    return C_TradeSkillUI.IsTradeSkillLinked()
end

function IsTradeSkillGuild()
    return C_TradeSkillUI.IsTradeSkillGuild()
end

function TradeSkillOnlyShowMakeable()
    return C_TradeSkillUI.SetOnlyShowMakeableRecipes(not C_TradeSkillUI.GetOnlyShowMakeableRecipes())
end

function TradeSkillOnlyShowSkillUps()
    return C_TradeSkillUI.SetOnlyShowSkillUpRecipes(not C_TradeSkillUI.GetOnlyShowSkillUpRecipes())
end

function TradeSkillSetFilter(subclass, slot, subName, slotName, subclassCategory)
	C_TradeSkillUI.ClearInventorySlotFilter()
	C_TradeSkillUI.ClearRecipeCategoryFilter()

    if categoryID or subCategoryID then
        C_TradeSkillUI.SetRecipeCategoryFilter(subclass, subclassCategory);
    end
    
    if inventorySlotIndex then
        C_TradeSkillUI.SetInventorySlotFilter(slot, true, true)
    end
end

function SetTradeSkillItemNameFilter(text)
    C_TradeSkillUI.SetRecipeItemNameFilter(text)
end

function GetTradeSkillListLink()
    return C_TradeSkillUI.GetTradeSkillListLink()
end

function GetTradeSkillItemLink(index)
    return C_TradeSkillUI.GetRecipeItemLink(index)
end

function GetTradeSkillRecipeLink(index)
    return C_TradeSkillUI.GetRecipeLink(index)
end

function GetTradeSkillInfo(index)
    local info = C_TradeSkillUI.GetRecipeInfo(index)
    -- skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps, indentLevel, showProgressBar, currentRank, maxRank, startingRank
    if info then
        return info.name, info.difficulty, info.numAvailable, false, info.alternateVerb, info.numSkillUps, info.numIndents, false, nil, nil, nil
    end
end

function GetTradeSkillCooldown(index)
    return C_TradeSkillUI.GetRecipeCooldown(index)
end

function GetTradeSkillSelectionIndex()
    return TradeSkillRecipeListMixin.selectedRecipeID or 0
end

function GetFirstTradeSkill()
    local recipeIDs = C_TradeSkillUI.GetFilteredRecipeIDs()
    for i, recipeID in ipairs(recipeIDs) do
        return recipeID
    end
end

function GetTradeSkillNumMade(skillIndex)
    return C_TradeSkillUI.GetRecipeNumItemsProduced(skillIndex)
end

function GetTradeSkillIcon(skillIndex)
    return C_TradeSkillUI.GetRecipeInfo(skillIndex).icon
end

function GetTradeSkillDescription(skillIndex)
    return C_TradeSkillUI.GetRecipeDescription(skillIndex)
end

function GetTradeSkillTools(skillIndex)
    return C_TradeSkillUI.GetRecipeTools(skillIndex)
end

function GetTradeSkillReagentInfo(skillIndex, i)
    return C_TradeSkillUI.GetRecipeReagentInfo(skillIndex, i)
end

function GetTradeSkillReagentItemLink(skillIndex, i)
    return C_TradeSkillUI.GetRecipeReagentItemLink(skillIndex, i)
end

function ADDON:ShowOrToggleTradeSkillFrame(profID)
	if (not IsAddOnLoaded("Blizzard_TradeSkillUI")) then LoadAddOn("Blizzard_TradeSkillUI") end
	-- ADDON:Debug("ShowOrToggleTradeSkillFrame:"..profID)
	
	local profname,_,icon = GetSpellInfo(profID)
	if (not profname) then return end

	if (profname == "Archaeology") then 
		ADDON:ToggleArchaeologyFrame()
		return
	end

	local requestedTradeSkillID = ADDON:GetProfSkillID(profID)
	local currenttradetkilline = C_TradeSkillUI.GetTradeSkillLine()

	if (currenttradetkilline ~= nil) then
		ADDON:Debug("changedTradeSkillID:"..select(1,currenttradetkilline))
	end

	if (currenttradetkilline == nil or tonumber(select(1,currenttradetkilline)) ~= tonumber(requestedTradeSkillID)) then
		if (IsAddOnLoaded("Blizzard_ArchaeologyUI") and ArchaeologyFrame:IsShown()) then 
			HideUIPanel(ArchaeologyFrame) 
		end
		C_TradeSkillUI.OpenTradeSkill(requestedTradeSkillID)
	elseif (TradeSkillFrame:IsVisible()) then 
		C_TradeSkillUI.CloseTradeSkill() 
	end
end

function ADDON:ShowTradeSkillFrame(profID)
	if (not IsAddOnLoaded("Blizzard_TradeSkillUI")) then LoadAddOn("Blizzard_TradeSkillUI") end
	ADDON:Debug("ShowTradeSkillFrame:"..profID)
	if (TradeSkillFrame:IsVisible()) then 
		C_TradeSkillUI.CloseTradeSkill() 
	end
	C_TradeSkillUI.OpenTradeSkill(ADDON:GetProfSkillID(profID))
end

function ADDON:ToggleArchaeologyFrame()
	if (not IsAddOnLoaded("Blizzard_ArchaeologyUI")) then LoadAddOn("Blizzard_ArchaeologyUI") end
	ADDON:Debug("ToggleArchaeologyFrame:")
	if (ArchaeologyFrame:IsShown()) then 
		HideUIPanel(ArchaeologyFrame) 
	else 
		if (IsAddOnLoaded("Blizzard_TradeSkillUI") and TradeSkillFrame:IsVisible()) then 
			C_TradeSkillUI.CloseTradeSkill() 
		end
		ShowUIPanel(ArchaeologyFrame)
	end
end
